/*
[9] -> 0 nic , 1-8   typ kreslenia
[10] -> 0 nic 1-9 typ grafu : 
	    1 : 8-10 riedky  2 : 8-10 husty 3 : 11-14 riedky 4 : 11-14 husty 5: 15-19 riedky 6:15-19 husty
	    7: 20-35 riedky  8: 36-59 riedky 60-100 riedky
*/



#include <stdio.h> 

const int MAX_UDAJOV = 1000000;
const int TYP_KRESLENIA = 8;
const int TYP_GRAFU = 7;

const int ALGORITMUS = 4; // 1 = heu 1 , 2 = heu 2 , 3 = spring 4= spring narar

FILE *in,*out;

int pocet=0;

int hrany[MAX_UDAJOV+1];
int poc[TYP_KRESLENIA+1][TYP_GRAFU+1];                 // pocet takychto grafov
int cross[TYP_KRESLENIA+1][TYP_GRAFU+1];               // pocet krizeni
int f2_cislo[TYP_KRESLENIA+1][TYP_GRAFU+1];
int najlep[TYP_KRESLENIA+1][TYP_GRAFU+1];

int nacitaj()
{
  if ((in=fopen("test.out","rt"))==NULL)
  {
    printf("Chyba, nemozem otvorit vstupny subor !!!\n");
    return(-1);    
  }
  
  int i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12; 
  int i;

  float caaas;
  
  int max_hran;
  
  int par1=0,par2=0,hranas=0;
  
  int counter=0;

  int minim=100;
  int min_kde[TYP_KRESLENIA+1];

  int pomoc;
  for (pomoc=1;pomoc<=TYP_KRESLENIA;pomoc++) min_kde[pomoc]=0;
  
  while (!feof(in))
  {
    pocet++;
    fscanf(in,"%d %d %d %d %d %d %d %d %d %d %d %d %f\n",&i1,&i2,&i3,&i4,&i5,&i6,&i7,&i8,&i9,&i10,&i11,&i12,&caaas);
    
    max_hran=i1*(i1-1)/2;
    hranas=i4*100/max_hran;
    hrany[pocet]=hranas;
        
    if ((i8>=101+10*ALGORITMUS)&&(i8<=108+10*ALGORITMUS))  
    {
      counter++;  
    
      par1=i8%10;
      
      if (par1==1) par1=1; else
      if (par1==2) par1=5; else
      if (par1==3) par1=3; else
      if (par1==4) par1=7; else
      if (par1==5) par1=2; else
      if (par1==6) par1=6; else
      if (par1==7) par1=4; else
      if (par1==8) par1=8; 

      if (minim==i12) min_kde[par1]=1;
      if (minim>i12)
      {
        for (pomoc=1;pomoc<=TYP_KRESLENIA;pomoc++) min_kde[pomoc]=0;      
        min_kde[par1]=1;
	minim=i12;      
      }

      par2=0;
      if ((i1>=8)&(i1<=10)&(hranas<=25)) par2=1;
      if ((i1>=8)&(i1<=10)&(hranas>25)) par2=1;
      if ((i1>=11)&(i1<=14)&(hranas<=25)) par2=2;
      if ((i1>=11)&(i1<=14)&(hranas>25)) par2=3;
      if ((i1>=15)&(i1<=19)&(hranas<=25)) par2=4;
      if ((i1>=15)&(i1<=19)&(hranas>25)) par2=5;
      if ((i1>=20)&(i1<=30)&(hranas<=20)) par2=6;
      if ((i1>=31)&(i1<=50)&(hranas<=12)) par2=7;
//      if ((i1>=60)&(i1<=100)) par2=9;     
      
      poc[par1][par2]++;
      cross[par1][par2]+=i10;
      f2_cislo[par1][par2]+=i9;
    
//      printf("zac\n");
      
      if (i8==108+10*ALGORITMUS)
      {
        for (pomoc=1;pomoc<=TYP_KRESLENIA;pomoc++) if (min_kde[pomoc]==1) 
	{  
	  najlep[pomoc][par2]++;                         
//	  printf("%d %d %d \n",counter,pomoc,par2);	  
	}  
        minim=100;
        for (pomoc=1;pomoc<=TYP_KRESLENIA;pomoc++) min_kde[pomoc]=0;      
	
      }
      
//      printf("kon\n");
      
//      printf("zapisujem : %d %d \n ",par1,par2);    
    
    }
    
 //   printf("pocet udajov : %d %d %d %d\n",pocet,i1,i4,i8);
  }  
  
//  printf("som tu \n");
  
  for (i=1;i<=TYP_KRESLENIA;i++)
  {
    printf("Typ %d ",i);
    
    for (i2=1;i2<=TYP_GRAFU;i2++)
    {
      if (poc[i][i2]!=0)
      {
        cross[i][i2]/=poc[i][i2];
        f2_cislo[i][i2]/=poc[i][i2];
      }
      float kkk;
      kkk=float(float(100*najlep[i][i2])/float(poc[i][i2]));
      printf("%d %d %d %3.2f||",poc[i][i2],cross[i][i2],f2_cislo[i][i2],kkk);    
    }
    printf("\n");
  }
  
  int sucet_hran=0;
  for (i=1;i<=pocet;i++) sucet_hran+=hrany[i];
  
//  printf("sucet hran : %d priemer %d ",sucet_hran,sucet_hran/pocet);
  

  fclose(in);
  
  return(0);
}

int vytvor_tab()
{
  int i,i2; 

  char* vystup;
  
  if (ALGORITMUS==1) vystup="heu1.tex";
  if (ALGORITMUS==2) vystup="heu2.tex";
  if (ALGORITMUS==3) vystup="spring.tex";
  if (ALGORITMUS==4) vystup="spring_nar.tex";

  if ((out=fopen(vystup,"wt"))==NULL)
  {
    printf("Chyba, nemozem otvorit vstupny subor !!!\n");
    return(-1);    
  }

  //tuto z udajov vytvorim tabulku 
  fprintf(out,"\\begin{tabular}{|c||c|c|c||c|c|c||c|c|c||c|c|c||c|c|c||c|c|c||c|c|c||c|c|c|}\n\n");    
  
  fprintf(out,"\\hline\n");
  
  //tuto spravit viacrozmerne bunky -> multibunky
  fprintf(out," &");  
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{135}$}\n &",ALGORITMUS);  
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{136}$}\n &",ALGORITMUS);
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{145}$}\n &",ALGORITMUS);
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{146}$}\n",ALGORITMUS);  
  fprintf(out,"\n\\\\ \\hline\n");    
  
  //hlavicku spravit :)
  fprintf(out," ");
  for (i=1;i<=TYP_KRESLENIA/2;i++) fprintf(out,"&\\textbf{P\\%%}&\\textbf{Cr}&\\textbf{2F}\n",i,i,i);
  fprintf(out,"\\\\\n");
  fprintf(out,"\\hline\n");


  int min1[TYP_GRAFU+1];
  int min2[TYP_GRAFU+1];
  float min3[TYP_GRAFU+1];

  for (i2=1;i2<=TYP_GRAFU;i2++)
  {
    min1[i2]=100000;
    min2[i2]=100000;
    min3[i2]=-1;
  }
  
  for (i2=1;i2<=TYP_GRAFU;i2++)
  {
    for (i=1;i<=TYP_KRESLENIA;i++)
    {
      float kkk=float(float(100*najlep[i][i2])/float(poc[i][i2]));
      if (kkk>min3[i2]) min3[i2]=kkk;
      if (cross[i][i2]<min1[i2]) min1[i2]=cross[i][i2];
      if (f2_cislo[i][i2]<min2[i2]) min2[i2]=f2_cislo[i][i2];        
    }
  }
  
  
  for (i2=1;i2<=TYP_GRAFU;i2++)
  {

    fprintf(out,"\\textbf{G}$_{%d}$",i2);
//    fprintf(out,"13");
    for (i=1;i<=TYP_KRESLENIA/2;i++)
    {
      float kkk=float(float(100*najlep[i][i2])/float(poc[i][i2]));
      fprintf(out,"&");
      if (min3[i2]==kkk) fprintf(out,"\\textbf{");
      fprintf(out,"%2.0f",kkk);
      if (min3[i2]==kkk) fprintf(out,"}");
//      fprintf(out,"&%d",poc[i][i2]);
      fprintf(out,"&");
      if (cross[i][i2]==min1[i2]) fprintf(out,"\\textbf{");
      fprintf(out,"%d",cross[i][i2]);
      if (cross[i][i2]==min1[i2]) fprintf(out,"}");
      fprintf(out,"&");
      if (f2_cislo[i][i2]==min2[i2]) fprintf(out,"\\textbf{");
      fprintf(out,"%d",f2_cislo[i][i2]);
      if (f2_cislo[i][i2]==min2[i2]) fprintf(out,"}");        
    }
     fprintf(out,"\n\\\\ \\hline\n");    
//    fprintf(out,"\\\\");
  }

  //tuto spravit viacrozmerne bunky -> multibunky
  fprintf(out," &");  
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{235}$}\n &",ALGORITMUS);  
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{236}$}\n &",ALGORITMUS);
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{245}$}\n &",ALGORITMUS);
  fprintf(out,"\\multicolumn{3}{|c||}{\\textbf{A%d}$_{246}$}\n",ALGORITMUS);  
  fprintf(out,"\n\\\\ \\hline\n");    


  for (i=TYP_KRESLENIA/2+1;i<=TYP_KRESLENIA;i++) fprintf(out,"&\\textbf{P\\%%}&\\textbf{Cr}&\\textbf{2F}\n",i,i,i);
  fprintf(out,"\\\\\n");
  fprintf(out,"\\hline\n");
  
  for (i2=1;i2<=TYP_GRAFU;i2++)
  {
    fprintf(out,"\\textbf{G}$_{%d}$",i2);
//    fprintf(out,"13");
    for (i=TYP_KRESLENIA/2+1;i<=TYP_KRESLENIA;i++) 
    {
      float kkk=float(float(100*najlep[i][i2])/float(poc[i][i2]));
      fprintf(out,"&");
      if (min3[i2]==kkk) fprintf(out,"\\textbf{");
      fprintf(out,"%2.0f",kkk);
      if (min3[i2]==kkk) fprintf(out,"}");
//      fprintf(out,"&%d",poc[i][i2]);
      fprintf(out,"&");
      if (cross[i][i2]==min1[i2]) fprintf(out,"\\textbf{");
      fprintf(out,"%d",cross[i][i2]);
      if (cross[i][i2]==min1[i2]) fprintf(out,"}");
      fprintf(out,"&");
      if (f2_cislo[i][i2]==min2[i2]) fprintf(out,"\\textbf{");
      fprintf(out,"%d",f2_cislo[i][i2]);
      if (f2_cislo[i][i2]==min2[i2]) fprintf(out,"}");
    }
     fprintf(out,"\n\\\\ \\hline\n");    
//    fprintf(out,"\\\\");
  }


  fprintf(out,"\n\\end{tabular}\n");

  fclose(out);
  return(0);
}

int main()
{
  int i,i2;
  
  for (i=1;i<=TYP_KRESLENIA;i++) for (i2=1;i2<=TYP_GRAFU;i2++)
  {
    poc[i][i2]=0;
    cross[i][i2]=0;
    f2_cislo[i][i2]=0;  
    najlep[i][i2]=0;
  }
  
  i=nacitaj();
  if (i==0) vytvor_tab();


  printf("pocet udajov : %d \n",pocet);
}
